<template>
  <div>
    <div>
      <div v-if="imageId" class="d-flex">
        <div class="w-25">
          <div class="aspect-box overflow-hidden">
            <div class="aspect-container">
              <img
                :src="baseUrl + '/media/image/' + imageId + '?maxWidth=300'"
                class="w-100"
              />
            </div>
          </div>
        </div>
        <b-button
          @click="onDelete()"
          v-if="!disabled"
          class="ml-2"
          variant="danger"
        >
          <font-awesome-icon :icon="['fas', 'trash']" />
        </b-button>
      </div>

      <b-button
        @click="openModal"
        v-if="!disabled"
        variant="secondary"
        class="mt-2"
        >select image</b-button
      >
    </div>

    <b-modal ref="theModal" size="xl" centered title="Select or upload image">
      <h3>Upload</h3>
      <div>
        <SimpleFileUpload @input="loadData"></SimpleFileUpload>
      </div>

      <hr />

      <h3>Select</h3>
      <div class="row">
        <div v-for="image in images.content" :key="image.id" class="col-3 mb-4">
          <div class="aspect-box overflow-hidden">
            <div class="aspect-container">
              <img
                :src="baseUrl + '/media/image/' + image.id + '?maxWidth=300'"
                @click="selectImage(image)"
                :class="{ 'border-selected': isSelected(image.id) }"
                class="w-100 cursor-pointer"
              />
            </div>
          </div>
        </div>
      </div>

      <div class="mt-2 d-flex justify-content-end">
        <b-pagination
          v-model="currentPage"
          :total-rows="images.totalElements"
          :per-page="pageSize"
          @change="onPage"
        ></b-pagination>
      </div>

      <template slot="modal-footer">
        <b-button @click="closeModal" variant="success">close</b-button>
      </template>
    </b-modal>
  </div>
</template>

<script>
import SimpleFileUpload from './SimpleFileUpload';
export default {
  components: { SimpleFileUpload },
  props: {
    value: {
      type: Number,
      default: null,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      images: { content: [] },
      imageId: this.value,
      pageSize: 20,
      currentPage: 0,
    };
  },
  computed: {
    baseUrl() {
      return process.env.baseURL;
    },
  },
  mounted() {
    this.loadData();
  },
  methods: {
    onPage(page) {
      this.currentPage = page - 1;

      this.loadData();
    },
    openModal() {
      this.$refs.theModal.show();
    },
    closeModal() {
      this.$refs.theModal.hide();
    },
    isSelected(id) {
      return this.imageId === id;
    },
    selectImage(image) {
      this.imageId = image.id;

      this.$emit('input', this.imageId);
    },
    async loadData() {
      const loader = this.$loading.show();

      const result = await this.$axios.$get(
        `/admin/upload?pageNumber=${this.currentPage}&pageSize=20`
      );

      this.images = result;

      loader.hide();

      // this.$emit('input', this.imageId);
    },
    onDelete() {
      this.imageId = null;

      this.$emit('input', this.imageId);
    },
  },
};
</script>
